"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
exports.getVariablesAst = function (node) {
    var variable = undefined;
    graphql_1.visit(node, {
        VariableDefinition: function (node) {
            variable = node;
        },
    });
    return variable;
};
exports.getOperationsMap = function (allAst) {
    var unknownCounter = 0;
    var operations = [];
    graphql_1.visit(allAst, {
        leave: {
            OperationDefinition: function (node) {
                var _a;
                var name = ((_a = node.name) === null || _a === void 0 ? void 0 : _a.value) || 'Unknown_' + ++unknownCounter;
                var operation = node === null || node === void 0 ? void 0 : node.operation;
                var variables = exports.getVariablesAst(node);
                operations.push({
                    operationName: name,
                    hasVariables: !!variables,
                    operation: operation,
                });
            },
        },
    });
    return operations;
};
//# sourceMappingURL=operationsParser.js.map