"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var operationsParser_1 = require("./operationsParser");
var printer_1 = require("./printer");
exports.plugin = function (schema, rawDocuments, config) {
    var documents = rawDocuments;
    var allAst = graphql_1.concatAST(documents.map(function (v) { return v.document; }).filter(function (x) { return !!x; }));
    var operations = operationsParser_1.getOperationsMap(allAst);
    var operationsMapPrinter = new printer_1.OperationsPrinter(operations, config);
    return operationsMapPrinter.operationsMapInterface;
};
//# sourceMappingURL=plugin.js.map