"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var changeCase = __importStar(require("change-case"));
var esprima_1 = require("esprima");
var static_eval_1 = __importDefault(require("static-eval"));
var casingOperations = Object.keys(changeCase)
    .map(function (x) {
    var _a;
    return (_a = {}, _a[x] = changeCase[x], _a);
})
    .reduce(function (l, r) { return (__assign(__assign({}, l), r)); }, {});
var getName = function (template, variables) {
    var ast = esprima_1.parse('`' + template + '`').body[0].expression;
    return static_eval_1.default(ast, __assign(__assign({}, casingOperations), variables));
};
var ensureConfigDefaults = function (config) {
    var _a = config.templates, _b = _a === void 0 ? {} : _a, _c = _b.operationType, operationType = _c === void 0 ? '${pascalCase(operationName)}Query' : _c, _d = _b.variablesType, variablesType = _d === void 0 ? '${pascalCase(operationName)}QueryVariables' : _d, _e = _b.operationName, operationName = _e === void 0 ? '${operationName}' : _e;
    return { operationType: operationType, variablesType: variablesType, operationName: operationName };
};
var OperationsPrinter = /** @class */ (function () {
    function OperationsPrinter(operations, config) {
        this.operations = operations;
        this.config = ensureConfigDefaults(config);
    }
    Object.defineProperty(OperationsPrinter.prototype, "operationsMapFields", {
        get: function () {
            var _a = this.config, operationName = _a.operationName, operationType = _a.operationType, variablesType = _a.variablesType;
            return this.operations
                .map(function (x) {
                var opName = getName(operationName, x);
                var opType = getName(operationType, x);
                var varType = getName(variablesType, x);
                return "'" + opName + "': { operationType: " + opType + ", variablesType: " + varType + ", type: '" + x.operation + "' }";
            })
                .join('\n  ');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OperationsPrinter.prototype, "operationsMapInterface", {
        get: function () {
            return "export interface OperationsMap {\n  " + this.operationsMapFields + "\n}";
        },
        enumerable: true,
        configurable: true
    });
    return OperationsPrinter;
}());
exports.OperationsPrinter = OperationsPrinter;
//# sourceMappingURL=printer.js.map